<?php

/**
 * @file
 * TODO.
 */

/**
 * Form builder.
 */
function gcc_contextual_block_config($form, $form_state) {

  $form = array();

  $form['basic'] = array(

    '#type' => 'fieldset',
    '#collapsible' => TRUE,
    '#title' => t('Basic configuration'),
  );

  $themes = list_themes();
  $options = array();
  foreach ($themes as $key => $theme) {
    if ($theme->status) {
      $options[$key] = $theme->info['name'];
    }
  }

  $config = variable_get('gcc_contextual_block_config', array());
  $form['config'] = array('#tree' => TRUE);

  foreach (variable_get('gcc_contextual_block_theme', array()) as $theme) {

    $blocks = _block_rehash($theme);
    $regions = system_region_list($theme, REGIONS_VISIBLE);
    $regions[GCC_CONTEXTUAL_BLOCK_HIDDEN] = t('Hidden');

    $form['config'][$theme] = array(

      '#type' => 'fieldset',
      '#collapsible' => TRUE,
      '#collapsed' => TRUE,
      '#title' => $themes[$theme]->info['name'],
      '#regions' => $regions,
      '#blocks' => $blocks,
      '#pre_render' => array('gcc_contextual_block_table'),
    );

    foreach ($blocks as $block) {

      $form['config'][$theme][$block['bid']]['config_customize'] = array(

        '#type' => 'checkbox',
        '#title' => '',
        '#default_value' => isset($config[$theme][$block['bid']]['config_customize']) ? $config[$theme][$block['bid']]['config_customize'] : 0,
      );

      $form['config'][$theme][$block['bid']]['region_customize'] = array(

        '#type' => 'checkbox',
        '#title' => '',
        '#default_value' => isset($config[$theme][$block['bid']]['region_customize']) ? $config[$theme][$block['bid']]['region_customize'] : 0,
      );

      $form['config'][$theme][$block['bid']]['regions'] = array(

        '#type' => 'checkboxes',
        '#title' => '',
        '#options' => $regions,
        '#default_value' => isset($config[$theme][$block['bid']]['regions']) ? $config[$theme][$block['bid']]['regions'] : array(),
      );
    }
  }

  $form['basic']['gcc_contextual_block_theme'] = array(

    '#type' => 'checkboxes',
    '#options' => $options,
    '#default_value' => variable_get('gcc_contextual_block_theme', array()),
    '#title' => t('Themes'),
    '#description' => t('Choose for which theme you want to allow to customize the block disposition and configuration'),
  );

  $form['actions'] = array('#type' => 'actions');

  $form['actions']['submit'] = array(

    '#type' => 'submit',
    '#value' => t('Save configuration'),
  );

  return $form;
}

/**
 * Theme callback.
 */
function gcc_contextual_block_table($element) {

  $regions = $element['#regions'];
  $blocks = $element['#blocks'];

  $header = array(
    t('Block Name'),
    t('Allow configuration customization'),
    t('Allow region customization'),
  );

  foreach ($regions as $region) {
    $header[] = $region;
  }

  $element['table'] = array(

    '#theme' => 'table',
    '#header' => $header,
    '#rows' => array(),
  );

  $rows = array();
  foreach ($blocks as $block) {

    $row = array();
    $row[] = $block['info'];
    $row[] = array('data' => $element[$block['bid']]['config_customize']);
    $row[] = array('data' => $element[$block['bid']]['region_customize']);

    foreach ($regions as $key => $name) {

      $element[$block['bid']]['regions'][$key]['#title'] = '';
      $row[] = array('data' => $element[$block['bid']]['regions'][$key]);
    }

    $rows[] = $row;

    unset($element[$block['bid']]);
  }

  $element['table']['#rows'] = $rows;

  return $element;
}

/**
 * Submit handler.
 */
function gcc_contextual_block_config_submit($form, &$form_state) {

  variable_set('gcc_contextual_block_theme', array_filter($form_state['values']['gcc_contextual_block_theme']));
  variable_set('gcc_contextual_block_config', $form_state['values']['config']);

  drupal_set_message(t('The configuration options have been saved.'));
}
